src/DelegateWise/Controllers/LoginController.cs
using System;
using System.Collections.Generic;
using System.Security.Claims;
using System.Threading.Tasks;
using DelegateWise.Data.Exceptions;
using DelegateWise.Models;
using DelegateWise.ViewModels;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Mvc;

namespace delegatewise.Controllers
{
    public class LoginController : MyController
    {
        public IActionResult Index()
        {
            try
            {
                LoggedUser();
                return View("../Logs/Index", new LogsViewModel());
            }
            catch (NotLoggedException)
            {
                return View();
            }
        }

        [HttpPost]
        public async Task<ActionResult> Index(User credentials)
        {
            try
            {
                var user = Dal.Login(credentials.Email, credentials.Password);
                var claims = new List<Claim>()
                {
                    new Claim(ClaimTypes.Name, user.Id.ToString()),
                    new Claim(ClaimTypes.Role, user.Admin ? "Admin" : "User"),
                };

                var claimsIdentity = new ClaimsIdentity(claims, CookieAuthenticationDefaults.AuthenticationScheme);
                var authProperties = new AuthenticationProperties
                {
                    AllowRefresh = true,
                    ExpiresUtc = DateTimeOffset.UtcNow.AddMinutes(10),
                    IsPersistent = true,
                    IssuedUtc = DateTimeOffset.UtcNow,
                };

                await HttpContext.SignInAsync(
                    CookieAuthenticationDefaults.AuthenticationScheme,
                    new ClaimsPrincipal(claimsIdentity),
                    authProperties);
                Dal.UpdateLogs();

                return RedirectToAction("Index", "Logs");
            }
            catch (WrongPasswordException)
            {
            }
            catch (UserNotFoundException)
            {
            }
            ModelState.AddModelError("User.Email", "Wrong Credentials");
            return View();
        }

        public IActionResult Logout()
        {
            Disconnect();
            return Redirect("/");
        }
    }
}

src/DelegateWise/Controllers/UsersController.cs
using System;
using DelegateWise.Data.Exceptions;
using DelegateWise.Models;
using DelegateWise.ViewModels;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using static DelegateWise.Models.SortMethod;

namespace delegatewise.Controllers
{
    [Authorize(Roles = "Admin")]
    public class UsersController : MyController
    {
        public IActionResult Index(SortMethod? sortMethod)
        {
            return View(new ListViewModel(Dal.GetUsers(), sortMethod));
        }

        public IActionResult GenerateInvitation()
        {
            string websiteHost = Environment.GetEnvironmentVariable("DELEGATEWISE_BACKOFFICE_WEBSITE_HOST");
            ViewData["Link"] = websiteHost + "/Join/" + Dal.GenerateInvitation();
            return View("Generate");
        }

        public IActionResult Edit(int id)
        {
            try
            {
                return View(Dal.GetUser(id));
            }
            catch (UserNotFoundException)
            {
                return RedirectToAction("Index");
            }
        }

        [HttpPost]
        public IActionResult Edit(User user)
        {
            if (!ModelState.IsValid)
                return View(user);
            try
            {
                Dal.EditUser(user);
                return RedirectToAction("Index");
            }
            catch (EmailAlreadyUsedException e)
            {
                ModelState.AddModelError("Email", e.Message);
                return View(user);
            }
        }

        public IActionResult Delete(int id)
        {
            if (LoggedUser().Id == id)
                return RedirectToAction("Index");
            try
            {
                Dal.DeleteUser(Dal.GetUser(id));
            }
            catch (UserNotFoundException)
            {
            }
            return RedirectToAction("Index");
        }
    }
}

src/DelegateWise/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>@ViewData["Title"] - @ViewData["AppName"]</title>
    <link rel="stylesheet" type="text/css" href="~/lib/bootstrap/dist/css/bootstrap.min.css"/>
    <link rel="stylesheet" type="text/css" href="~/css/site.css" runat="server"/>
    <link rel="stylesheet" type="text/css" href="~/css/daterangepicker.css" runat="server"/>
</head>
<body>
<header>
    <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
        <div class="container">
            <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Delegate Wise</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                <ul class="navbar-nav flex-grow-1">
                    <li class="nav-item">
                        @Html.ActionLink("Logs", "Index", "Logs",null, new {id = "element" })
                    </li>
                    <li class="nav-item">
                        @Html.ActionLink("Account", "Index", "Account",null, new {id = "element" })
                    </li>
                    @if (User.IsInRole("Admin"))
                    {
                        <li class="nav-item">
                            @Html.ActionLink("Invite", "GenerateInvitation", "Users",null, new {id = "element" })
                        </li>
                        <li class="nav-item">
                            @Html.ActionLink("Users", "Index", "Users",null, new {id = "element" })
                        </li>
                    }
                    <li class="nav-item">
                        @Html.ActionLink("Logout", "Logout", "Login",null, new {id = "element" })
                    </li>

                </ul>
            </div>
        </div>
    </nav>
</header>
<div class="container">
    <main role="main" class="pb-3">
        @RenderBody()
    </main>
</div>
<script src="~/lib/jquery/dist/jquery.min.js"></script>
<script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
<script src="~/js/canvasjs.min.js"></script>
<script type="text/javascript" src="https://cdn.jsdelivr.net/jquery/latest/jquery.min.js"></script>
<script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment.min.js"></script>
<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
@RenderSection("Scripts", required: false)
</body>
</html>

src/DelegateWise/Views/Shared/_LayoutPrivate.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>@ViewData["Title"] - @ViewData["AppName"]</title>
    <link rel="stylesheet" type="text/css" href="~/css/site.css" runat="server"/>
</head>
<body>
<div class="container">
    <main role="main" class="pb-3">
        @RenderBody()
    </main>
</div>
</body>
</html>